<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAPILiveAdvertPosting ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAPILiveAdvertPosting
 * @subpackage Arrays
 */
class ArrayOfAPILiveAdvertPosting extends AbstractStructArrayBase
{
    /**
     * The APILiveAdvertPosting
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting[]
     */
    public $APILiveAdvertPosting;
    /**
     * Constructor method for ArrayOfAPILiveAdvertPosting
     * @uses ArrayOfAPILiveAdvertPosting::setAPILiveAdvertPosting()
     * @param \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting[] $aPILiveAdvertPosting
     */
    public function __construct(array $aPILiveAdvertPosting = array())
    {
        $this
            ->setAPILiveAdvertPosting($aPILiveAdvertPosting);
    }
    /**
     * Get APILiveAdvertPosting value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting[]|null
     */
    public function getAPILiveAdvertPosting()
    {
        return isset($this->APILiveAdvertPosting) ? $this->APILiveAdvertPosting : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAPILiveAdvertPosting method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAPILiveAdvertPosting method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAPILiveAdvertPostingForArrayConstraintsFromSetAPILiveAdvertPosting(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem) {
            // validation for constraint: itemType
            if (!$arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem instanceof \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting) {
                $invalidValues[] = is_object($arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem) ? get_class($arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem) : sprintf('%s(%s)', gettype($arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem), var_export($arrayOfAPILiveAdvertPostingAPILiveAdvertPostingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The APILiveAdvertPosting property can only contain items of type \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set APILiveAdvertPosting value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting[] $aPILiveAdvertPosting
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPILiveAdvertPosting
     */
    public function setAPILiveAdvertPosting(array $aPILiveAdvertPosting = array())
    {
        // validation for constraint: array
        if ('' !== ($aPILiveAdvertPostingArrayErrorMessage = self::validateAPILiveAdvertPostingForArrayConstraintsFromSetAPILiveAdvertPosting($aPILiveAdvertPosting))) {
            throw new \InvalidArgumentException($aPILiveAdvertPostingArrayErrorMessage, __LINE__);
        }
        if (is_null($aPILiveAdvertPosting) || (is_array($aPILiveAdvertPosting) && empty($aPILiveAdvertPosting))) {
            unset($this->APILiveAdvertPosting);
        } else {
            $this->APILiveAdvertPosting = $aPILiveAdvertPosting;
        }
        return $this;
    }
    /**
     * Add item to APILiveAdvertPosting value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPILiveAdvertPosting
     */
    public function addToAPILiveAdvertPosting(\RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting) {
            throw new \InvalidArgumentException(sprintf('The APILiveAdvertPosting property can only contain items of type \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->APILiveAdvertPosting[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\APILiveAdvertPosting|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string APILiveAdvertPosting
     */
    public function getAttributeName()
    {
        return 'APILiveAdvertPosting';
    }
}
